package net.jieyuu.controller;


import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import net.jieyuu.service.AddressService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 电商-公司收发货地址表 前端控制器
 * </p>
 *
 * @author jieyuu
 * @since 2024-02-12
 */
@Api(tags = "收货地址模块")
@RestController
@RequestMapping("/api/adderss/v1/")
public class AddressController {

    @Autowired
    AddressService addressService;

    @ApiOperation("根据id查询地址详情")
    @GetMapping("detail/{address_id}")
    public Object detail(
            @ApiParam(value = "地址", required = true)
            @PathVariable("address_id") long id) {
        return addressService.detail(id);
    }

}

