package net.jieyuu.service.impl;

import lombok.extern.slf4j.Slf4j;
import net.jieyuu.enums.SendCodeEnum;
import net.jieyuu.service.MailService;
import net.jieyuu.service.NotifyService;
import net.jieyuu.utils.CheckUtil;
import net.jieyuu.utils.CommonUtil;
import net.jieyuu.utils.JsonData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.security.auth.Subject;

@Slf4j
@Service
public class NotifyServiceImpl implements NotifyService {

    @Autowired
    private MailService mailService;

    @Autowired
    private RedisTemplate redisTemplate;

    public static final String SUBJECT = "验证码";
    public static final String CONTENT = "您的验证码是%s，有效时间为60秒";


    /**
     * 前置判断：判断是否重复发送
     * 1 存储验证码到缓存
     *
     * 2 发送验证码
     * 后置 存储发送记录
     *
     * @param sendCodeType
     * @param to
     * @return
     */
    @Override
    public JsonData sendCode(SendCodeEnum sendCodeType, String to) {
        if (CheckUtil.isEmail(to)) {
            //邮箱验证码
            String code = CommonUtil.getRandomCode(6);
            mailService.sendMail(to, SUBJECT, String.format(CONTENT, code));
            return JsonData.buildSuccess();

        } else if (CheckUtil.isPhone(to)) {
            //短信验证码

        }

        return null;
    }
}
